// imd Timer.C

#include "imdTimer.h"

volatile uint16_t timer[10];
volatile uint16_t sTimer;
volatile long time;
volatile int timeStart;

ISR(TIMER1_COMPA_vect){
	int i;
	for(i=0;i<10;i++){
		if(timer[i])timer[i]--;
	}
	if(sTimer)sTimer--;
	if(timeStart){
		time++;
		if(time>=360000)time = 0;
	}
}

void InitTimer(){
	TCCR1A = 0; // mode:ctc
	TCCR1B = (1<<WGM12)|(0b010<<CS10);// mode:ctc clk/8 
	TCNT1 = 0;
	OCR1A = 12500; // 100Hz @ 10MHz
	TIMSK1 = (1<<OCIE1A); // OCIE interrupt enable
	int i;
	for(i=0;i<10;i++){
		timer[i]=0;
	}
	sTimer = 0;
	time = 0;
	timeStart = 0;
}	

void MSTimer(uint16_t ms){
	uint16_t time;
	time = ms/10;
	if(time<2) time=2;
	cli();
	sTimer = time;
	sei();
	while(sTimer);
}
