/* ---------------------------------------------

	[ lcdsub.c ]

	t`֘ATu[`
	for YHY024006A
	(c) 2010, By Y.Kyotani
------------------------------------------------
    modified by ImaDen 
	MMC֌W폜
	WindowAreaݒ葼ǉ
--------------------------------------------- */

#include	<avr/io.h>
#include	<avr/pgmspace.h>
#include	<stdlib.h>

//#include	"timer644.h"
#include	"imdTimer.h"
#include	"lcdsub.h"

/* ------------------------------------ PORTA */
#define		_RES	7

/* ------------------------------------ PORTB */
#define		_CS	0
#define		_RS	1
#define		_WR	2
#define		_RD	3

/* ---------------------------------- STR CMD */
#define		CMD_ENDJOB	0x0000
#define		CMD_MSTIMER	0xffff


#define SCREENGX     320
#define SCREENGY     240




/* ASCIItHg(8x8Dot) */
//extern const prog_uchar ankfont[];
//extern const prog_uchar exfont[];

/* ---------------------------------------------

	[J֐vg^Cv

--------------------------------------------- */
void LcdOut(uint16_t index, uint16_t data);
void LcdStrOut(const prog_uint16_t *outstr);
void SetWindowParam(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2);
void LCDFillBoxA(void);

void MMC2LcdSub0(uint16_t len);
void MMC2LcdSub1(uint16_t len);
void MMC2LcdSub2(uint16_t len);
void MMC2LcdSub3(uint16_t len);

void LCDPutChrP(const prog_uchar *p1, const prog_uchar *p2);

/* ---------------------------------------------

	LCDf[^o͊֐

--------------------------------------------- */
void LcdOut(uint16_t index, uint16_t data)
	{
	/* Index */
	PORTB &= ~(1<<_CS);			// CS
	PORTB &= ~(1<<_RS);			// R}h[h
	PORTD = 0;				// ʃoCg(0Œ)
	PORTC = (uint8_t)(index & 0xff);	// ʃoCg
	PORTB &= ~(1<<_WR);			// WR
	PORTB |= (1<<_WR);			// WR

	/* Data */
	PORTB |= (1<<_RS);			// f[^[h
	PORTD = (uint8_t)(data >> 8);		// ʃoCg
	PORTC = (uint8_t)(data & 0xff);		// ʃoCg
	PORTB &= ~(1<<_WR);			// WR
	PORTB |= (1<<_WR);			// WR

	PORTB |= (1<<_CS);			// CS
	}

void LcdStrOut(const prog_uint16_t *outstr)
	{
	uint16_t	index, data;

	for	( ; ; )
		{
		switch	(index= pgm_read_word_near(outstr++))
			{
			case	CMD_ENDJOB:
				return;
			case	CMD_MSTIMER:
				data= pgm_read_word_near(outstr++);
				MSTimer	(data);
				continue;
			default:
				LcdOut	(index, pgm_read_word_near(outstr++));
			}
		}
	}

/* ---------------------------------------------

	LCD֐

--------------------------------------------- */

const prog_uint16_t InitData[]=
	{
	0x00E3, 0x3008,				// Set internal timing
	0x00E7, 0x0012,				// Set internal timing
	0x00EF, 0x1231,				// Set internal timing
	0x0001, 0x0000,				// set SS and SM bit (Edit org=0x0100)
	0x0002, 0x0700,				// set line inversion
	0x0003, 0x0038,				// set GRAM write direction and BGR=0, 16bit color (Edit org=0x1018)
	0x0004, 0x0000,				// Resize register

	0x0008, 0x0207,				// set the back porch and front porch
	0x0009, 0x0000,				// set non-display area refresh cycle ISC[3:0]
	0x000A, 0x0000,				// FMARK function
	0x000C, 0x0000,				// RGB interface setting
	0x000D, 0x0000,				// Frame marker Position
	0x000F, 0x0000,				// RGB interface polarity
	//--------------Power On sequence --------------//
	0x0010, 0x0000,				// SAP); Trans_Dat_16(BT[3:0]); Trans_Dat_16(AP); Trans_Dat_16(DSTB); Trans_Dat_16(SLP); Trans_Dat_16(STB
	0x0011, 0x0007,				// DC1[2:0]); Trans_Dat_16(DC0[2:0]); Trans_Dat_16(VC[2:0]
	0x0012, 0x0000,				// VREG1OUT voltage
	0x0013, 0x0000,				// VDV[4:0] for VCOM amplitude
	CMD_MSTIMER, 200,			// Dis-charge capacitor power voltage
	0x0010, 0x1490,				// SAP); Trans_Dat_16(BT[3:0]); Trans_Dat_16(AP); Trans_Dat_16(DSTB); Trans_Dat_16(SLP); Trans_Dat_16(STB
	0x0011, 0x0227,				// R11h=0x0221 at VCI=3.3V); Trans_Dat_16(DC1[2:0]); Trans_Dat_16(DC0[2:0]); Trans_Dat_16(VC[2:0]
	CMD_MSTIMER, 50,			// Delayms 50ms
	0x0012, 0x001c,				// External reference voltage= Vci;
	CMD_MSTIMER, 50,			// Delayms 50ms
	0x0013, 0x0A00,				// R13=0F00 when R12=009E;VDV[4:0] for VCOM amplitude
	0x0029, 0x000F,				// R29=0019 when R12=009E;VCM[5:0] for VCOMH//0012//
	0x002B, 0x000D,				// Frame Rate = 91Hz
	CMD_MSTIMER, 50,			// Delayms 50ms
	0x0020, 0x0000,				// GRAM horizontal Address
	0x0021, 0x0000,				// GRAM Vertical Address
	// ----------- Adjust the Gamma Curve ----------//
	0x0030, 0x0000,				// 
	0x0031, 0x0203,				// 
	0x0032, 0x0001,				// 
	0x0035, 0x0205,				// 
	0x0036, 0x030C,				// 
	0x0037, 0x0607,				// 
	0x0038, 0x0405,				// 
	0x0039, 0x0707,				// 
	0x003C, 0x0502,				// 
	0x003D, 0x1008,				// 
	//------------------ Set GRAM area ---------------//
	0x0050, 0x0000,				// Horizontal GRAM Start Address
	0x0051, 0x00EF,				// Horizontal GRAM End Address
	0x0052, 0x0000,				// Vertical GRAM Start Address
	0x0053, 0x013F,				// Vertical GRAM Start Address
	0x0060, 0xA700,				// Gate Scan Line
	0x0061, 0x0001,				// NDL,VLE); Trans_Dat_16(REV
	0x006A, 0x0000,				// set scrolling line
	//-------------- Partial Display Control ---------//
	0x0080, 0x0000,				// 
	0x0081, 0x0000,				// 
	0x0082, 0x0000,				// 
	0x0083, 0x0000,				// 
	0x0084, 0x0000,				// 
	0x0085, 0x0000,				// 
	//-------------- Panel Control -------------------//
	0x0090, 0x0010,				// 
	0x0092, 0x0600,				// 0x0000
	0x0093, 0x0003,				// 
	0x0095, 0x0110,				// 
	0x0097, 0x0000,				// 
	0x0098, 0x0000,				// 
	0x0007, 0x0133,				// 262K color and display ON

	CMD_ENDJOB
	};

void LcdInit(void)
	{
	PORTB |= (1<<_CS) | (1<<_RS) | (1<<_WR) | (1<<_RD);
	PORTA |= (1<<_RES);			// RESET

	MSTimer	(20);				// 20mS wait
	PORTA &= ~(1<<_RES);			// RESET
	MSTimer	(10);				// >1mS(10mS) wait
	PORTA |= (1<<_RES);			// RESET
	MSTimer	(30);				// >25ms(30ms) wait

	LcdStrOut	(InitData);
	}

/* ---------------------------------------------

	EBhEGAݒ肷

	dx, dy <-- OtBbNC[W̑傫
	ofstx, ofsty <-- C[W̃ItZbg
	ret --> 0:OK, 1:ItZbg␳,
	        2:w肳ꂽTCYNG

--------------------------------------------- */
int SetWindowArea(int dx, int dy, int ofstx, int ofsty)
	{
	int	sx, sy, res;
	
	if	(dx > SCREENGX || dy > SCREENGY)
		return	2;
	
	res= 0;
	sx= (SCREENGX - dx) / 2 + ofstx;
	if	(sx < 0)		{ sx=0; res=1; }
	else if	(sx > SCREENGX-dx)	{ sx=SCREENGX-dx; res=1; }
	sy= (SCREENGY - dy) / 2 + ofsty;
	if	(sy < 0)		{ sy=0; res=1; }
	else if	(sy > SCREENGY-dy)	{ sy=SCREENGY-dy; res=1; }
	
	SetWindowParam	((uint16_t)sx, (uint16_t)sy, (uint16_t)(sx+dx-1), (uint16_t)(sy+dy-1));
	
	return	res;
	}

// ʒuݒ
int SetWindowArea2(int left,int top,int right,int bottom){
	SetWindowParam ((uint16_t)left,(uint16_t)top,(uint16_t)right,(uint16_t)bottom);
	return 1;
}


void SetWindowParam(uint16_t x1, uint16_t y1, uint16_t x2, uint16_t y2)
	{
	LcdOut(0x0003, 0x0038);			// Entry Mode: AM BitONɂ
	
	LcdOut(0x0050, y1);			// HSA
	LcdOut(0x0051, y2);			// HEA
	LcdOut(0x0052, x1);			// VSA
	LcdOut(0x0053, x2);			// VEA
	LcdOut(0x0020, y1);			// _Zbg
	LcdOut(0x0021, x1);
	}

void InitWindowArea(void) //
	{
	SetWindowParam	(0, 0, SCREENGX-1, SCREENGY-1);
	}


/* ---------------------------------------------

	ʑŜEwFŖ߂

--------------------------------------------- */
void GCls(uint16_t col)
	{
	InitWindowArea	(); // EBhEGARQO@QSOɐݒ肷
	
	LcdFill	((uint32_t)SCREENGX * (uint32_t)SCREENGY, col);
	}


/* ---------------------------------------------

	LCDwFŖ߂

--------------------------------------------- */
void LcdFill(uint32_t len, uint16_t col)
	{
	/* Index */
	PORTB &= ~(1<<_CS);			// CS
	PORTB &= ~(1<<_RS);			// R}h[h
	PORTD = 0;				// CMD(0Œ)
	PORTC = 0x22;				// CMD(0x22 Write to GRAM)
	PORTB &= ~(1<<_WR);			// WR
	PORTB |= (1<<_WR);			// WR

	/* Data */
	PORTB |= (1<<_RS);			// f[^[h
	PORTD = (uint8_t)(col >> 8);		// ʃoCg
	PORTC = (uint8_t)(col & 0xff);		// ʃoCg

	while	(len >= 8L)
		{
		// 1
		PINB = 1<<_WR;				// WR
		PINB = 1<<_WR;				// WR
		// 2
		PINB = 1<<_WR;				// WR
		PINB = 1<<_WR;				// WR
		// 3
		PINB = 1<<_WR;				// WR
		PINB = 1<<_WR;				// WR
		// 4
		PINB = 1<<_WR;				// WR
		PINB = 1<<_WR;				// WR
		// 5
		PINB = 1<<_WR;				// WR
		PINB = 1<<_WR;				// WR
		// 6
		PINB = 1<<_WR;				// WR
		PINB = 1<<_WR;				// WR
		// 7
		PINB = 1<<_WR;				// WR
		PINB = 1<<_WR;				// WR
		// 8
		PINB = 1<<_WR;				// WR
		PINB = 1<<_WR;				// WR
		
		len -= 8L;
		}

	while	(len)
		{
		// 1
		PINB = 1<<_WR;				// WR
		PINB = 1<<_WR;				// WR
		
		len--;
		}


	PORTB |= (1<<_CS);			// CS
	}

/* ---------------------------------------------

	obt@Oꂽf[^]

--------------------------------------------- */
void LcdTrans(uint8_t *buff, uint16_t len)
	{
	/* Index */
	PORTB &= ~(1<<_CS);			// CS
	PORTB &= ~(1<<_RS);			// R}h[h
	PORTD = 0;				// CMD(0Œ)
	PORTC = 0x22;				// CMD(0x22 Write to GRAM)
	PORTB &= ~(1<<_WR);			// WR
	PORTB |= (1<<_WR);			// WR

	/* Data */
	PORTB |= (1<<_RS);			// f[^[h

	while	(len >= 8)
		{
		// 1
		PORTD = *buff++;
		PORTC = *buff++;
		PINB = 1<<_WR;				// WR
		PINB = 1<<_WR;				// WR
		// 2
		PORTD = *buff++;
		PORTC = *buff++;
		PINB = 1<<_WR;				// WR
		PINB = 1<<_WR;				// WR
		// 3
		PORTD = *buff++;
		PORTC = *buff++;
		PINB = 1<<_WR;				// WR
		PINB = 1<<_WR;				// WR
		// 4
		PORTD = *buff++;
		PORTC = *buff++;
		PINB = 1<<_WR;				// WR
		PINB = 1<<_WR;				// WR
		// 5
		PORTD = *buff++;
		PORTC = *buff++;
		PINB = 1<<_WR;				// WR
		PINB = 1<<_WR;				// WR
		// 6
		PORTD = *buff++;
		PORTC = *buff++;
		PINB = 1<<_WR;				// WR
		PINB = 1<<_WR;				// WR
		// 7
		PORTD = *buff++;
		PORTC = *buff++;
		PINB = 1<<_WR;				// WR
		PINB = 1<<_WR;				// WR
		// 8
		PORTD = *buff++;
		PORTC = *buff++;
		PINB = 1<<_WR;				// WR
		PINB = 1<<_WR;				// WR
		
		len -= 8;
		}

	while	(len)
		{
		// 1
		PORTD = *buff++;
		PORTC = *buff++;
		PINB = 1<<_WR;				// WR
		PINB = 1<<_WR;				// WR
		
		len--;
		}


	PORTB |= (1<<_CS);			// CS
	}

//-------- ǉ

void InitLcdPort(){

	/* e|[g */
	PORTA = 0b10000000;	// 10000000
	DDRA  = 0b11100000;	// oooIIIII
	
	PORTB = 0b00111111;	// 0_111111
	DDRB  = 0b10111111;	// oIoooooo
	
	PORTC = 0b00000000;	// 00000000
	DDRC  = 0b11111111;	// oooooooo
	
	PORTD = 0b00000000;	// 00000000
	DDRD  = 0b11111111;	// oooooooo
	
}


// WX^CfbNXZbg
void SetRegIndex(uint16_t index){
	/* Index */
	PORTB &= ~(1<<_CS);			// CS
	PORTB &= ~(1<<_RS);			// R}h[h
	PORTD = 0;				// ʃoCg(0Œ)
	PORTC = (uint8_t)(index & 0xff);	// ʃoCg
	PORTB &= ~(1<<_WR);			// WR
	PORTB |= (1<<_WR);			// WR
	PORTB |= (1<<_CS);
}
// f[^[
void WriteLcdData(uint16_t data){
		/* Data */
	PORTB &= ~(1<<_CS);
	PORTB |= (1<<_RS);			// f[^[h
	PORTD = (uint8_t)(data >> 8);		// ʃoCg
	PORTC = (uint8_t)(data & 0xff);		// ʃoCg
	PORTB &= ~(1<<_WR);			// WR
	PORTB |= (1<<_WR);			// WR

	PORTB |= (1<<_CS);			// CS
}

// f[^[[h
uint16_t ReadLcdData(){
	uint16_t h,l;
	DDRC = 0; 
	DDRD = 0;

	PORTB &= ~(1<<_CS);
	PORTB |= (1<<_RS);			// f[^[h
	PORTB &= ~(1<<_RD);			// WR
	h = PIND; //h	// ʃoCg
	l = PINC; //l 	// ʃoCg
	PORTB |= (1<<_RD);			// WR

	PORTB |= (1<<_CS);			// CS
	DDRC = 0xFF;
	DDRD = 0xFF;
	return (h<<8)&l;
}	
// ʃAhXݒ
int SetXY(uint16_t X,uint16_t Y){
	LcdOut(0x20,Y);
	LcdOut(0x21,X);
	return 1;
}


// 2bit pbg`
int WriteLcdFromPrgmPlt2(int left,int top,prog_uchar *ch){
	uint8_t palette[4][3];
	int bpp,width,height;
	bpp = pgm_read_byte(ch);ch++;
	width = ((int)pgm_read_byte(ch)<<8);ch++;
	width |= pgm_read_byte(ch);ch++;
	height = ((int)pgm_read_byte(ch)<<8);ch++;
	height |= pgm_read_byte(ch);ch++;
	int i,j;
	for(i=0;i<4;i++){
		for(j=0;j<3;j++){
			palette[i][j]=pgm_read_byte(ch);ch++;
		}
	}
	int x,y,idx;
	idx=0;// oCgCfbNX
	x=0;
	uint8_t colno;
	for(y=0;y<height;y++){
		SetXY(x+left,y+top);
		SetRegIndex(0x22); //f[^[݃CfbNX
		for(;x<width;x++){
			colno = (pgm_read_byte(ch) >> (idx*2))& 0b11;
			WriteLcdData(RGB2U16(palette[colno][0],palette[colno][1],palette[colno][2]));
			idx++;
			if(idx>=4){
				idx=0;
				ch++;
			}
		}
		x=0;
	}
	return 1;
}

// 4bit pbg`
int WriteLcdFromPrgmPlt4(int left,int top,prog_uchar *ch){
	uint8_t palette[16][3];
	int width,height,bpp;
	bpp = pgm_read_byte(ch);ch++;
	width = ((int)pgm_read_byte(ch)<<8);ch++;
	width |= pgm_read_byte(ch);ch++;
	height = ((int)pgm_read_byte(ch)<<8);ch++;
	height |= pgm_read_byte(ch);ch++;
	int i,j;
	for(i=0;i<16;i++){
		for(j=0;j<3;j++){
			palette[i][j]=pgm_read_byte(ch);ch++;
		}
	}
	int x,y,idx;
	idx=0;// oCgCfbNX
	x=0;
	uint8_t colno;
	for(y=0;y<height;y++){
		SetXY(x+left,y+top);
		SetRegIndex(0x22); //f[^[݃CfbNX
		for(;x<width;x++){
			colno = (pgm_read_byte(ch) >> (idx*4))& 0b11;
			WriteLcdData(RGB2U16(palette[colno][0],palette[colno][1],palette[colno][2]));
			idx++;
			if(idx>=2){
				idx=0;
				ch++;
			}
		}
		x=0;
	}
	return 1;
}

int WriteLcdFromPrgm16(int left,int top,prog_uchar *ch){
	int width,height,bpp;
	bpp = pgm_read_byte(ch);ch++;
	width = (int)pgm_read_byte(ch)<<8;ch++;
	width |= pgm_read_byte(ch);ch++;
	height = (int)pgm_read_byte(ch)<<8;ch++;
	height |= pgm_read_byte(ch);ch++;
	uint16_t color;
	uint8_t h,l;
	int x,y;
	for(y=0;y<height;y++){
		x=0;
		SetXY(left+x,top+y);
		SetRegIndex(0x22);
		for(;x<width;x++){
			h = pgm_read_byte(ch);ch++;
			l = pgm_read_byte(ch);ch++;
			color = (h&0xF8)<<8;		// B
			color |= ((h&0x07)<<8)|(l&0xE0);	//G
			color |= (l&0x1F);	//R
			WriteLcdData(color);
		}
	}
	return 1;
}

int WriteLcdFromPrgm24(int left,int top,prog_uchar *ch){
	int width,height,bpp;
	bpp = pgm_read_byte(ch);ch++;
	width = (int)pgm_read_byte(ch)<<8;ch++;
	width |= pgm_read_byte(ch);ch++;
	height = (int)pgm_read_byte(ch)<<8;ch++;
	height |= pgm_read_byte(ch);ch++;
	uint8_t r,g,b;
	int x,y;
	for(y=0;y<height;y++){
		x=0;
		SetXY(left+x,top+y);
		SetRegIndex(0x22);
		for(;x<width;x++){
			r = pgm_read_byte(ch);ch++;
			g = pgm_read_byte(ch);ch++;
			b = pgm_read_byte(ch);ch++;
			WriteLcdData(RGB2U16(r,g,b));
		}
	}
	return 1;
}

// vỎ摜\
int WriteLcdFromPrgm(int left,int top,prog_uchar *ch){
	switch(pgm_read_byte(&ch[0])){
		case 2:
			WriteLcdFromPrgmPlt2(left,top,ch);
			break;
		case 4:
			WriteLcdFromPrgmPlt4(left,top,ch);
			break;
		case 16:
//			GCls(0);
			WriteLcdFromPrgm16(left,top,ch);
			break;
		case 24:
			WriteLcdFromPrgm24(left,top,ch);
			break;
		default:
			break;
	}
	return 1;
}

int WriteLcdFromPrgmR(RECT rect,prog_uchar *ch){
	return WriteLcdFromPrgm(rect.left,rect.top,ch);
}

// X,Yɓ_ł
int SetPoint(int x, int y, uint16_t color){
	SetXY(x,y);
	LcdOut(0x22,color);
	return 1;
}

// tHgg \
int PutStr(int left,int top,uint16_t fColor,uint16_t bColor,char *str,prog_uchar *font){
	prog_uchar *pFont = font;
	uint16_t topChar;
	topChar = ((uint16_t)pgm_read_byte(pFont)<<8)&0xFF00;pFont++;
	topChar |= pgm_read_byte(pFont)&0xFF;pFont++;
	int fontX,fontY;
	fontX = (pgm_read_byte(pFont)<<8)&0xFF00; pFont++;
	fontX |= pgm_read_byte(pFont)&0xFF; pFont++;
	fontY = (pgm_read_byte(pFont)<<8)&0xFF00; pFont++;
	fontY |= pgm_read_byte(pFont)&0xFF; pFont++;
	int byteX = fontX/8; // ɕKvȃoCg
	if(fontX%8) byteX++;
	int fontSize = byteX*fontY;
	// 擪Zo 
	int nChar = 0; // L
	while(*str){
		int fontN = *str - topChar; // tHgԍZo
		int index = fontN*fontSize;
		int x,y;
		for(y=0;y<fontY;y++){
			uint8_t bitMusk = 1;
			x=0;
			SetXY(left+nChar*fontX,top+y);
			for(;x<fontX;x++){
				if(pgm_read_byte(pFont+index) & bitMusk) LcdOut(0x22,fColor);
				else LcdOut(0x22,bColor);
				bitMusk=bitMusk<<1;
				if(!bitMusk){
					bitMusk = 1;
					index++;
				}
			}
			index++;
		}
		str++; // 1I
		nChar++;
	}	
	return 1;
}

int PutStrR(RECT rect,uint16_t fColor,uint16_t bColor,char *str,prog_uchar font[]){
	return PutStr(rect.left,rect.top,fColor,bColor,str,font);
}

void BargraphH(int left,int top,int right,int bottom,int position
	,uint8_t LHome,uint8_t padShape,uint16_t fColor,uint16_t bColor){
	int width = abs(right-left);
	int height = abs(bottom-top);
	if(position<0) position = 0;
	if(position>1000) position = 1000;
	int pos = (int)((long)width*(long)position/(long)1000); // \ʒuZo
	int xp;
	for(int y=0;y<=height;y++){
		int x=0;
		SetXY(left+x,top+y);
		SetRegIndex(0x22);
		for(;x<=width;x++){
			if(LHome) xp=x; else xp=width-x;
			if(pos == xp)WriteLcdData(fColor);
			else if((pos==0) && (xp==0)) WriteLcdData(fColor); // E[ɂƂ͐c
			else if((pos>=width)&&(xp>=width))WriteLcdData(fColor);
			else if(padShape && (pos>xp))WriteLcdData(fColor);
			else WriteLcdData(bColor);
		}
	}
}

void BargraphHR(RECT rect,int position,uint8_t LHome,uint8_t padShape,uint16_t fColor,uint16_t bColor){
	BargraphH(rect.left,rect.top,rect.right,rect.bottom,position,LHome,padShape,fColor,bColor);
}

void BargraphV(int left,int top,int right,int bottom,int position
	,uint8_t DHome,uint8_t padShape,uint16_t fColor,uint16_t bColor){
	int width = abs(right-left);
	int height = abs(bottom-top);
	if(position<0) position = 0;
	if(position>1000) position = 1000;
	int pos = (int)((long)height*(long)position/(long)1000); // \ʒuZo
	int yp;
	for(int y=0;y<=height;y++){
		int x=0;
		SetXY(left+x,top+y);
		SetRegIndex(0x22);
		if(!DHome) yp=y; else yp=height-y;
		for(;x<=width;x++){
			if(pos == yp)WriteLcdData(fColor);
			else if((pos==0)&&(yp==0)) WriteLcdData(fColor);
			else if((pos>=height)&&(yp>=height))WriteLcdData(fColor);
			else if(padShape && (pos>yp))WriteLcdData(fColor);
			else WriteLcdData(bColor);
		}
	}
}

void BargraphVR(RECT rect,int position,uint8_t DHome,uint8_t padShape,uint16_t fColor,uint16_t bColor){
	BargraphV(rect.left,rect.top,rect.right,rect.bottom,position,DHome,padShape,fColor,bColor);
}

void NormalizeRect(RECT *pRect){
	int tmp;
	if(pRect->top > pRect->bottom){
		tmp = pRect->top;
		pRect->top = pRect->bottom;
		pRect->bottom = tmp;
	}
	if(pRect->left > pRect->right){
		tmp = pRect->left;
		pRect->left = pRect->right;
		pRect->right = tmp;
	}
}

// lp`FbN pRect == 0Ȃɂnj
int CheckInRect(int x,int y,RECT *pRect){
	if(pRect == 0) return 1;
	if((pRect->left > x)||(pRect->right < x)) return 0;
	if((pRect->top > y)||(pRect->bottom < y)) return 0;
	return 1;
} 

void DrawLine(int x1,int y1,int x2,int y2,uint16_t color,RECT *pRect)
{
	if(pRect)NormalizeRect(pRect);
	int px;  //݁A_łĂW
	int py;

	int counter = 0;  //JE^

	int dstX;  //n_I_܂ł̋
	int dstY;

	int addX;  //
	int addY;

	//n_I_܂ł́Ax,yꂼ̋߂
	dstX = x2-x1;
	if(dstX < 0){
		dstX *= -1;  //0ȉȂ畄]
		addX = -1;
	}else{
		addX = 1;
	}
	dstY = y2 - y1;
	if(dstY < 0){
		dstY *= -1;  //0ȉȂ畄]
		addY = -1;
	}else{
		addY = 1;
	}
	px = x1;  //(x1,y1)̈ʒun߂
	py = y1;

	//r
	if(dstX > dstY){
		// Xɓ_łĂ
		counter = dstY; // W񕪒ǉ@ŃlCeBuƂقڈv
		for(int i=0;i<=dstX;i++){
			if(CheckInRect(px,py,pRect))
				SetPoint(px,py,color);// œ_`
			counter += dstY;
			if(counter > ((dstX>>1)+1)){
				counter -= dstX;
				py += addY;
			}
			px += addX;
		}
	}else{
		// Yɓ_łĂ
		counter = dstX; // W񕪒ǉ+1ŃJ[u̐܂_C
		for(int i=0;i<=dstY;i++){
			if(CheckInRect(px,py,pRect))
				SetPoint(px,py,color);
			counter += dstX;
			if(counter > ((dstY>>1)+1)){//-1ŃJ[u̐܂_C
				counter -= dstY;
				px += addX;
			}
			py += addY;
		}
	}
}
