
/* ---------------------------------------------

	[ timer644.c ]

	^C}[֘ATu[`
	(c) 2010, By Y.Kyotani

--------------------------------------------- */

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/wdt.h>

#include "timer644.h"

//#define	FOSC		10000000			// 10MHz
#define FOSC		F_CPU
#define	PSCALE		8				// vXP[[
#define	FINT60		60				// ŏIIȊ荞ݎg(60Hz)
#define	FINT100		100				//          //           (100Hz)
#define	FINT240		240				//          //           (240Hz)
#define	FINT1K		1000				//          //           (1KHz)
#define	OCRV60		(FOSC/PSCALE/FINT60-1)		// OCRnɐݒ肷l(60Hz)
#define	OCRV100		(FOSC/PSCALE/FINT100-1)		//          //     (100Hz)
#define	OCRV240		(FOSC/PSCALE/FINT240-1)		//          //     (240Hz)
#define	OCRV1K		(FOSC/PSCALE/FINT1K-1)		//          //     (1KHz)
#define	TMR60		1				// [Nւ̎ʒl(60Hz)
#define	TMR100		2				//          //     (100Hz)
#define	TMR240		3				//          //     (240Hz)
#define	TMR1K		4				//          //     (1KHz)


/* gpϐ */
volatile uint16_t		TimerCount;
volatile uint8_t		TimerFlag;

uint8_t			TimerSetting;		// 1:60Hz, 2:100Hz, 3:240Hz, 4:1KHz

/* ---------------------------------------------

	^C}[̃CjVCY

--------------------------------------------- */

void TimerInit(void)
	{
	uint8_t	sregsave;

	sregsave= SREG;				// Xe[^XWX^ۑ
	cli	();				// ֎~

	// TCCR1Bݒ1 (܂gp~)
	// ICNC1:	0	(Capture1 Noise Cancel֎~)
	// ICES1:	0	(Capture1 Edge Select)
	// WGM13,12:	0 1	(CTC OCR1Av)
	// CS12,11,10:	0 0 0	(JEg~)
	TCCR1B= (1<<WGM12);
	
	// TCCR1Aݒ
	// COM1A1,0:	0 0	(ORC1Ao͐ؒf/W|[g)
	// COM1B1,0:	0 0	(ORC1Bo͐ؒf/W|[g)
	// WGM11,10:	0 0	(CTC OCR1Av)
	TCCR1A= 0;
	
	// OCR1AH, Lݒ (100Hzŏ)
	TCNT1H= 0;
	TCNT1L= 0;
	OCR1AH= (uint8_t)(OCRV100 >> 8);
	OCR1AL= (uint8_t) OCRV100;
	TimerSetting= TMR100;			// 2:100Hz
	
	// TIMSK1ݒ
	// TCIE1:	0	(Capture1֎~)
	// OCIE1B:	0	(OCR1Bv֎~)
	// OCIE1A:	1	(OCR1Av)
	// TOIE1:	0	(Timer1 Overflow֎~)
	TIMSK1= (1<<OCIE1A);
	
	// TCCR1Bݒ2 (胂[hŎgp)
	// ICNC1:	0	(Capture1 Noise Cancel֎~)
	// ICES1:	0	(Capture1 Edge Select)
	// WGM13,12:	0 1	(CTC OCR1Av)
	// CS12,11,10:	0 1 0	(vXP[[ 1/8)
	TCCR1B= (1<<WGM12) | (1<<CS11);

	SREG= sregsave;				// Xe[^XWX^A
	}

/* ---------------------------------------------

	^C}[OCR1Av荞ݏ

--------------------------------------------- */

SIGNAL(TIMER1_COMPA_vect)
	{
	if	(TimerCount)
		TimerCount--;			// ^C}[JEg0ȂJEg_E
	TimerFlag= 0;				// ^C}[tONA
	}

/* ---------------------------------------------

	msPʂ̎ԑ҂s

	uint16_t loop msPʂ̑҂

--------------------------------------------- */

void TimerWait(void)
	{
	do
		{
//		wdt_reset();			// ԌNZbg
		}
	while	(TimerCount);			// JEg 0ɂȂ̂҂
	}

void MSTimerSet(uint16_t loop)
	{
	uint8_t	sregsave;

	sregsave= SREG;				// Xe[^XWX^ۑ
	cli	();				// ֎~

	if	(TimerSetting != TMR1K)
		{				// JEg[h1KHzȊOȂď
		TCNT1H= 0;
		TCNT1L= 0;
		OCR1AH= (uint8_t)(OCRV1K >> 8);	// OCR1AH, Lݒ (1KHzŏ)
		OCR1AL= (uint8_t) OCRV1K;
		TimerSetting= TMR1K;		// 4:1KHz
		}

	TimerCount= loop;			// JEg̏lZbg
	SREG= sregsave;				// Xe[^XWX^A
	}

void MSTimer(uint16_t loop)
	{
	MSTimerSet	(loop);
	TimerWait	();
	}

/* ---------------------------------------------

	1/nbPʂ̎ԑ҂s

	uint16_t ntime bPʂ̃R}(1/nb)
	n=1`60Ɍ

--------------------------------------------- */

void NNTimerSet(uint16_t ntime)
	{
	uint8_t	sregsave;

	ntime= (60 < ntime) ? (FINT240 / 60):
	   ntime? (FINT240 / ntime): FINT240;	// 1/240bPʂ̃JEg𓾂
	sregsave= SREG;				// Xe[^XWX^ۑ
	cli	();				// ֎~

	if	(TimerSetting != TMR240)
		{				// JEg[h240HzȊOȂď
		TCNT1H= 0;
		TCNT1L= 0;
		OCR1AH= (uint8_t)(OCRV240 >>8);	// OCR1AH, Lݒ (240Hzŏ)
		OCR1AL= (uint8_t) OCRV240;
		TimerSetting= TMR240;		// 3:240Hz
		}

	TimerCount= ntime;			// JEg̏lZbg
	SREG= sregsave;				// Xe[^XWX^A
	}


/* ---------------------------------------------

	1݂̂̎ԑ҂s
	̊荞݂Nꂽ߂

--------------------------------------------- */

void TimerOneShot(void)
	{
	TimerFlag= 1;				// tO𗧂ĂĂ
	do
		{
//		wdt_reset();			// ԌNZbg
		}
	while	(TimerFlag);			// tONÂ҂
	}

// End of timer644.c
