// stopwatch

#include <stdio.h>
#include <stdlib.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/interrupt.h>
#include <util/delay_basic.h>
#include "LcdCtrl.h"
#include "MainScreen.h"
#include "StStart.h"
#include "ststop.h"
#include "F10_6.h"
#include "F22_12Led.h"

#define SW1 2
#define SW2 3
#define SW3	4
#define SW1ON	(!(PINC & (1 << SW1)))
#define SW2ON	(!(PINC & (1 << SW2)))
#define SW3ON	(!(PINC & (1 << SW3)))

volatile long	time;	// ԃJEgp
volatile long	lap;	// bvێp
volatile uint8_t	time_start; // ^CJEgX^[gtO

#define SW_STABLE_TIME	3	// XCb`̃`^[LZ@mSec
#define SW_STABLE_COUNT (F_CPU/4)/(1000/SW_STABLE_TIME)	

ISR(PCINT1_vect){
	_delay_loop_2(SW_STABLE_COUNT); // XCb`莞
	if(SW1ON){
		if(time_start==0) time_start=1;
		else time_start = 0;
	}else if(SW2ON){
		if(time_start) lap = time;
	}
	PCIFR |= (1<<PCIF1); // dtONA
}

void SetSwitchIntr(){
	PCMSK1 = (1<<SW1)|(1<<SW2);
	PCICR = (1<<PCIE1);
}

// ^C}[荞
ISR(TIMER1_COMPA_vect){
	if(time_start){
		time++;
		if(time >= 360000) time = 0;
	}
}

// ^C}[I[o[t[EEĂĂ͍(^^;
ISR(TIMER1_OVF_vect){
	time = 0;
}

// ^C}[荞݂ݒ肷B
void SetTimeIntr(){
	PRR &= ~(1<<PRTIM1); // Enable Timer UNIT
	TCCR1A = 0;
	TCCR1B = (1<<WGM12) | (3 << CS10); // 1/64 Clock
	TCNT1 = 0;
	OCR1A = 3125;	// 0.01 Sec at 20MHz
//	OCR1A = 1250;   // 0.01 Sec at 8MHz
	time = 0;
	time_start=0;
	TIMSK1 |= (1<<OCIE1A);
}

// ԕ\
void DisplayTime(){
	int min,sec,sec1;
	char str[20];
	min = time/6000;
	sec = (time%6000)/100;
	sec1 = (time%100);
	sprintf(str,"%02d:%02d.%02d",min,sec,sec1);	//sprintfŎԂ𕶎ɕϊ
	PutStrR(digitTime_rect,str,F22_12Led_Font);	//̕\QQPQhbgtHg
}

// bv\
void DisplayLap(){
	int min,sec,sec1;
	char str[20];
	min = lap/6000;
	sec = (lap%6000)/100;
	sec1 = (lap%100);
	sprintf(str,"%02d:%02d.%02d",min,sec,sec1); //sprintfŎԂ𕶎ɕϊ
	PutStrR(lapTime_rect,str,F10_6_Font);	//\POUhbgtHg
}

int main(){
	InitLcd();
	DDRC = 0;
	PORTC = 0x1C; // PullUp 4,3,2

	SetTimeIntr();
	SetSwitchIntr();
	sei();
	// ܂Ń^C}[hn̏
	WriteLcdFromPrgm(0,0,MainScreen_LcdData);	//@Cʕ\	
	WriteLcdFromPrgmR(status_rect,ststop_LcdData);	// Xgbv\
	for(;;){
		if(SW3ON){ // Zbgrv`FbN
			if(!time_start){
				time = 0;
				lap = 0;
			}
		}
		if(time_start) WriteLcdFromPrgmR(status_rect,ststart_LcdData); // X^[g\
		else WriteLcdFromPrgmR(status_rect,ststop_LcdData); // Xgbv\
		DisplayTime();	// ԕ\
		DisplayLap();	// bv\
		int barTime = (long)time*(long)1000/(long)360000;
		BarGraphHR(barTime_rect,barTime,1,1); 	// o[Ot\
	}
}
