// c
// vscreen.c

#include <stdio.h>
#include <stdlib.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include "portdef.h"
#include "lcdctrl.h"
#include "V1.h"
#include "Btn1On.h"
#include "Btn1Off.h"
#include "Btn21.h"
#include "Btn22.h"
#include "Btn23.h"
#include "F10_6.h"

#define SW1 2
#define SW2 3
#define SW3	4
#define SW1ON	(!(PINC & (1 << SW1)))
#define SW2ON	(!(PINC & (1 << SW2)))
#define SW3ON	(!(PINC & (1 << SW3)))

uint8_t	sw1,sw2,sw3;
uint8_t sw2cnt;
int k;

int main(){
	sw1=sw2=sw3=0;
	k=0;
	InitLcd();
	DDRC = 0;
	PORTC = 0x1C; // PullUp4,3,2
	//ADC
	ADMUX = (1<<REFS0);
	ADCSRA = (1<<ADEN)|(4); // 1/16clk
	WriteLcdFromPrgm(0,0,V1_LcdData);
	WriteLcdFromPrgmR(BTN1_rect,Btn1Off_LcdData);
	sw2cnt = 0;
	WriteLcdFromPrgmR(BTN2_rect,Btn21_LcdData);
	for(;;){
		if((SW1ON)&&(!sw1)){
			sw1=1;
			WriteLcdFromPrgmR(BTN1_rect,Btn1On_LcdData);
		}
		if((!SW1ON)&&(sw1)){
			sw1=0;
			WriteLcdFromPrgmR(BTN1_rect,Btn1Off_LcdData);
		}
		if((SW2ON)&&(!sw2)){
			sw2=1;
			sw2cnt++;
			if((sw2cnt<0)||(sw2cnt>2))sw2cnt = 0;
			switch(sw2cnt){
				case 0:
					WriteLcdFromPrgmR(BTN2_rect,Btn21_LcdData);
					break;
				case 1:
					WriteLcdFromPrgmR(BTN2_rect,Btn22_LcdData);
					break;
				case 2:
					WriteLcdFromPrgmR(BTN2_rect,Btn23_LcdData);
					break;
			}
		}
		if(!SW2ON) sw2=0;
		if((SW3ON)&&(!sw3)){
			sw3=1;
		}
		if(!SW3ON) sw3=0;
		k+=10;
		if(k>1000)k=0;
		BarGraphVR(BART_rect,k,1,1);
		ADMUX &= 0xF0;
		ADCSRA |= (1<<ADSC);
		while(ADCSRA&(1<<ADSC));
		int ads1 = ADC;		// VR1̃f[^[擾
		ADMUX |= 1;
		ADCSRA |= (1<<ADSC);
		while(ADCSRA&(1<<ADSC));
		int ads2 = ADC;		// VR2̃f[^[擾
		char str[20];
		sprintf(str,"%+5d",ads1-ads2);
		PutStrVR(VTEXT1_rect,str,F10_6_Font); // VR1-VR2𐔒l\

		BarGraphHR(VBAR2_rect,ads2,0,1);
		BarGraphHR(VBAR1_rect,ads1,0,1);
		BarGraphVR(BAR1_rect,(ads1-ads2+500),0,0);
	}
}
